routes/web.php
<?php

use App\Http\Controllers\AlbumController;
use App\Http\Controllers\GalleryController;
use App\Http\Controllers\GalleryImageController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::group(['middleware' => ['auth']], function() {
    Route::resource('albums', AlbumController::class);
    Route::resource('galleries', GalleryController::class);
    // Route::resource('galleries/{gallery}/galleryimages', GalleryImageController::class);
    Route::get('galleries/{gallery}/galleryimages', [GalleryImageController::class, 'index'])->name('galleryimages.index');
    Route::post('galleries/{gallery}/galleryimages', [GalleryImageController::class, 'store'])->name('galleryimages.store');
    Route::get('galleries/{gallery}/galleryimages/create', [GalleryImageController::class, 'create'])->name('galleryimages.create');
    Route::put('galleries/{gallery}/galleryimages/update', [GalleryImageController::class, 'update'])->name('galleryimages.update');
    Route::put('galleries/{gallery}/galleryimages/updatesortorder', [GalleryImageController::class, 'updateSortOrder'])->name('galleryimages.updatesortorder');
});

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Gallery.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Gallery extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'published_by', 'album_id'];

    public function galleryImages()
    {
        return $this->hasMany(GalleryImage::class, 'gallery_id', 'id');
    }

    public function user()
    {
        return $this->belongsTo(User::class, 'published_by', 'id');
    }

    public function album()
    {
        return $this->belongsTo(Album::class, 'album_id', 'id');
    }
}

app/Http/Controllers/GalleryController.php
<?php

namespace App\Http\Controllers;

use App\Models\Album;
use App\Models\Gallery;
use Illuminate\Http\Request;

class GalleryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $galleries = Gallery::with('album')->get();

        $index = 0;

        return view('galleries.index', compact('galleries', 'index'));  
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $albums = Album::all();
        return view('galleries.create', compact('albums'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $galleryData = $this->validate($request, [
            'name' => 'required',
            'album_id' => 'required',
        ]);

        $galleryData['published_by'] = $request->post('published_by');    

        Gallery::create($galleryData);
        return redirect()->route('galleries.index')
                         ->with('success', 'Gallery added successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Gallery  $gallery
     * @return \Illuminate\Http\Response
     */
    public function show(Gallery $gallery)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Gallery  $gallery
     * @return \Illuminate\Http\Response
     */
    public function edit(Gallery $gallery)
    {
        $albums = Album::all();
        return view('galleries.edit', compact('gallery', 'albums'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Gallery  $gallery
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Gallery $gallery)
    {
        $galleryData = $this->validate($request, [
            'name' => 'required',
            'album_id' => 'required',
        ]);

        $galleryData['published_by'] = $request->post('published_by');    

        $gallery->update($galleryData);
        return redirect()->route('galleries.index')
                         ->with('success', 'Gallery updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Gallery  $gallery
     * @return \Illuminate\Http\Response
     */
    public function destroy(Gallery $gallery)
    {
        if($gallery->galleryImages()->count() == 0) {
            $gallery->delete();
            return redirect()->route('galleries.index')
                         ->with('success', 'Gallery deleted successfully');
        }
        return redirect()->route('galleries.index')
                         ->with('error', 'Gallery is associated with an image!');
    }
}

resources/views/galleries/create.blade.php
@extends('layouts.app')

@section('header-css')
    {{-- <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/dropzone/5.7.2/min/dropzone.min.css" integrity="sha512-bbUR1MeyQAnEuvdmss7V2LclMzO+R9BzRntEE57WIKInFVQjvX7l7QZSxjNDt8bg41Ww05oHSh0ycKFijqD7dA==" crossorigin="anonymous" /> --}}
@endsection

@section('content')

<div class="row">
    <div class="col-lg-12 margin-tb">
        <div class="float-left">
            <h2>New Gallery</h2>
        </div>
        <div class="float-right">
            <a class="btn btn-primary" href="{{ route('galleries.index') }}">Back</a>
        </div>
    </div>
</div>

@if(count($errors) > 0)
    <div class="alert alert-danger">
        <strong>Whoops!</strong> There were some problems with your input.<br><br>
        <ul>
            @foreach($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif

<form action="{{ route('galleries.store') }}" method="POST" enctype="multipart/form-data">
    @csrf
    <div class="row">
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <div class="form-group">
                <strong>Gallery Name:</strong>
                <input type="text" name="name" id="name" placeholder="Gallery Name" required class="form-control" value="{{ old('name') }}">
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <div class="form-group">
                <strong>Album:</strong>
                <select class="form-control" name="album_id" id="year" required>
                    <option value="">Select Album</option>
                    @foreach($albums as $album)
                        <option value="{{$album->id}}">{{$album->name}}</option>
                    @endforeach
                </select>
            </div>
        </div>
        {{-- <div class="col-xs-12 col-sm-12 cl-md-12">
            <div class="card mb-4">
                <div class="card-header">Select Images</div>
                <div class="card-body">
                    <div id="gallery-dropzone" class="dropzone"></div>
                </div>
            </div>
        </div> --}}
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <input type="hidden" name="published_by" value="{{ auth()->user()->id }}">
            <button type="submit" id="upload-file-and-submit" class="btn btn-primary">Save</button>
        </div>
    </div>
</form>

@endsection

@section('footer-scripts')
    {{-- <script src="https://cdnjs.cloudflare.com/ajax/libs/dropzone/5.7.2/min/dropzone.min.js" integrity="sha512-9WciDs0XP20sojTJ9E7mChDXy6pcO0qHpwbEJID1YVavz2H6QBz5eLoDD8lseZOb2yGT8xDNIV7HIe1ZbuiDWg==" crossorigin="anonymous"></script> --}}
@endsection

@section('extra-footer-scripts')
    <script>
        // Dropzone.autoDiscover = false;
        // var myDropzone = new Dropzone("#gallery-dropzone", { 
        //     url: '',
        //     addRemoveLinks: true,
        //     autoProcessQueue: false,
        //     maxFiles: 20,
        //     maxFilesize:5,//MB
        //     init: function () {
        //         this.on(
        //             "addedfile", function(file) {
        //                 caption = file.caption == undefined ? "" : file.caption;
        //                 file._captionLabel = Dropzone.createElement("<p>File Info:</p>")
        //                 file._captionBox = Dropzone.createElement("<input id='"+file.filename+"' type='text' name='caption' placeholder='Enter Caption' value="+caption+" >");
        //                 file.previewElement.appendChild(file._captionLabel);
        //                 file.previewElement.appendChild(file._captionBox);
        //             }
        //         ),
        //         this.on(
        //             "sending", function(file, xhr, formData){
        //                 formData.append('caption',file._captionBox.value);
        //             }
        //         )
        //     }
        // });     

        // $('#upload-file-and-submit').click(function() {
        //     myDropzone.processQueue();
        // });
    </script>
@endsection

resources/views/galleries/edit.blade.php
@extends('layouts.app')

@section('content')

<div class="row">
    <div class="col-lg-12 margin-tb">
        <div class="float-left">
            <h2>Edit Gallery</h2>
        </div>
        <div class="float-right">
            <a class="btn btn-primary" href="{{ route('galleries.index') }}">Back</a>
        </div>
    </div>
</div>

@if(count($errors) > 0)
    <div class="alert alert-danger">
        <strong>Whoops!</strong> There were some problems with your input.<br><br>
        <ul>
            @foreach($errors->all() as $error)
                <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
@endif

<form action="{{ route('galleries.update', $gallery->id) }}" method="POST">
    @csrf
    @method('PUT')
    <div class="row">
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <div class="form-group">
                <strong>Gallery Name:</strong>
                <input type="text" name="name" id="name" placeholder="Gallery Name" class="form-control" value="{{ $gallery->name }}">
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <div class="form-group">
                <strong>Album:</strong>
                <select class="form-control" name="album_id" id="year">
                    <option value="">Select Album</option>
                    @foreach($albums as $album)
                        <option @if(isset($gallery)) @if($album->id == $gallery->album_id) selected='selected' @endif @endif  value="{{$album->id}}">{{$album->name}}</option>
                    @endforeach
                </select>
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 cl-md-12">
            <input type="hidden" name="published_by" value="{{ auth()->user()->id }}">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>
    </div>
</form>

@endsection

resources/views/galleries/index.blade.php
@extends('layouts.app')

@section('header-css')
    <link rel="stylesheet" href="{{ asset('css/vendor/datatable/datatables.min.css') }}">
@endsection

@section('content')

<div class="row">
    <div class="col-lg-12 margin-tb">
        <div class="float-left">
            <h2>Galleries</h2>
        </div>
        <div class="float-right mb-4">
            <a class="btn btn-success" href="{{ route('galleries.create') }}">Create New Gallery</a>
        </div>
    </div>
</div>

@if($message = Session::get('success'))
    <div class="alert alert-success">
        <p>{{ $message }}</p>
    </div>
@endif

@if($message = Session::get('error'))
    <div class="alert alert-danger">
        <p>{{ $message }}</p>
    </div>
@endif

<table class="table table-striped table-bordered" id="datatable" style="width: 100%;">
    <thead>
        <tr>
            <th>No.</th>
            <th>Gallery</th>
            <th>Album</th>
            <th width="280px">Action</th>
        </tr>
    </thead>
    <tbody>
        @forelse($galleries as $key => $gallery)
            <tr>
                <td>{{ ++$index }}</td>
                <td>{{ $gallery->name }}</td>
                <td>{{ $gallery->album->name }}</td>
                <td width="300">
                    <a class="btn btn-primary" href="{{ route('galleries.edit', $gallery->id) }}">Edit</a>
                    <a class="btn btn-primary" href="{{ route('galleryimages.index', $gallery->id) }}">Manage Images</a>
                    <form method="POST" action="{{ route('galleries.destroy', $gallery->id) }}" style="display:inline">
                        @csrf
                        @method('DELETE')
                        <input type="submit" value="Delete" class="btn btn-danger show_confirm">
                    </form>
                </td>
            </tr>
        @empty
            <tr>
                <td class="text-center" colspan="6">No Galleries to list.</td>
            </tr>
        @endforelse
    </tbody>
</table>
@endsection

@section('footer-scripts')
    <script type="text/javascript" src="{{ asset('js/vendor/datatable/dataTables.min.js')}}"></script>
    <script type="text/javascript" src="{{ asset('js/vendor/datatable/dataTables.bootstrap4.min.js')}}"></script>
    <script type="text/javascript">
        jQuery('#datatable').DataTable();
    </script>
@endsection